/* *****  animplib.c       Time-stamp: <2001-01-10 19:45:40 t-kita>  ***** */

#include "animp.h"
#include <string.h>

/* #define PRINT_HANKAKU_PATTERN */

int _read_guide_check_flag= -1;
int _texnum = 0;
int _xy_range_check_flag= 0; /* 1 ˥åȤȥ顼åФ */

void set_pattern_size(int x, int y){
  X_max= x-1; Y_max= y-1;
  _read_guide_check_flag= 1;
}


int get_x_kosuu(){
  return X_max+1;
}

int get_y_kosuu(){
  return Y_max+1;
}



void print_pattern_with_num(){
  int i, j;

  _check_first_time();

  printf("\n");
#ifdef PRINT_HANKAKU_PATTERN
  for(j=0; j<=X_max; j++){  printf("%1d",j%10); }
#else
  for(j=0; j<=X_max; j++){  printf("%2d",j); }
#endif
  printf("\n");
  for(i=0; i<=Y_max; i++){
    for(j=0; j<=X_max; j++){
      if (ptt[i][j]==0){
#ifdef PRINT_HANKAKU_PATTERN
	printf(".");
#else
	printf("");
#endif
      }else{
#ifdef PRINT_HANKAKU_PATTERN
	printf("#");
#else
	printf("");
#endif
      }
    }
    printf(" %2d",i);
    printf("\n");
  }
  printf("\n");
}



void print_pattern(){
  int i, j;

  _check_first_time();

  printf("\n");
  for(i=0; i<=Y_max; i++){
    for(j=0; j<=X_max; j++){
      if (ptt[i][j]==0){
#ifdef PRINT_HANKAKU_PATTERN
	printf(".");
#else
	printf("");
#endif
      }else{
#ifdef PRINT_HANKAKU_PATTERN
	printf("#");
#else
	printf("");
#endif
      }
    }
    printf("\n");
  }
  printf("\n");
}


void print_pattern_to_png(){
  int i, j;
  FILE *fp;
  char fn[256]="";

  _check_first_time();

  sprintf(fn,"/tmp/anim%03d.tex",_texnum);
  printf("%s\n",fn);
  fp= fopen(fn,"w");

  fprintf(fp,"\\documentstyle[a4j]{jarticle}\\pagestyle{empty}\\begin{document}\\setlength{\\baselineskip}{0zh}\\begin{verbatim}\n");

  fprintf(fp,"\n");
  for(i=0; i<=Y_max; i++){
    for(j=0; j<=X_max; j++){
      if (ptt[i][j]==0){
#ifdef PRINT_HANKAKU_PATTERN
	fprintf(fp,".");
#else
	fprintf(fp,"");
#endif
      }else{
#ifdef PRINT_HANKAKU_PATTERN
	fprintf(fp,"#");
#else
	fprintf(fp,"");
#endif
      }
    }
    fprintf(fp,"\n");
  }
  fprintf(fp,"\n");

  fprintf(fp,"\\end{verbatim}\\end{document}\n");
  fclose(fp);
  
  sprintf(fn,"cd /tmp; jlatex anim%03d.tex; dvi2ps anim%03d.dvi > anim%03d.ps; dvips anim%03d; convert -density 57 -crop 0x0 anim%03d.ps anim%03d.png",_texnum,_texnum,_texnum,_texnum,_texnum,_texnum);
  system(fn);

  _texnum++;
}

void  make_animation_javascript(){
  system("perl5 make_animation_javascript.pl > /tmp/anim.html");
}


void die(char str[]){
  fprintf(stderr,"%s\n",str);
  exit(1);
}

void _check_first_time(){
  static int _first_time_check_flag= -1;
  int px, py;

  if (_read_guide_check_flag<0){
    die("ѥ礭ꤵƤޤ");
  }
  if (_first_time_check_flag<0){
    _first_time_check_flag= 1;
    srand(time(NULL));  /* Υɤѹ */
    /* clear all points. */
    for(px=0; px<=X_max; px++){
      for(py=0; py<=Y_max; py++){
	ptt[py][px]= 0;
      }
    }
  }
}

void clear_all_points(){
  int px, py;

  for(px=0; px<=X_max; px++){
    for(py=0; py<=Y_max; py++){
      clear_one_point(px, py);  /* ˤ */
    }
  }
}

void mark_all_points(){
  int px, py;

  for(px=0; px<=X_max; px++){
    for(py=0; py<=Y_max; py++){
      mark_one_point(px, py);  /* ˤ */
    }
  }
}


void make_random_pattern(){
  int px, py;

  /* Ŭ˥ѥ */
  for(px=0; px<=X_max; px++){
    for(py=0; py<=Y_max; py++){
      if (random_int(2)==0){  /* 0 or 1 */
	clear_one_point(px, py);  /* ˤ */
      }else{  /* 1 ξ */
	mark_one_point(px, py);   /* ˤ */
      }
    }
  }
}


void make_pattern(char *str){
  int i, j;
  char buf[10];
  int bufco= 0;
  int tate= 0, yoko= 0, curval= 0, runlength= 0;
  int tateco= 0, yokoco= 0;

  /* strǥɤƥѥ */
  for(i=0; ; i++){
    switch (str[i]){
    case '\0' :
      printf("make_pattern() : no code for pattern!\n");
      return;
      break;
    case ':':
      buf[bufco++]= '\0';  tate= atoi(buf);
      bufco= 0;
      break;
    case '#':
      buf[bufco++]= '\0';  yoko= atoi(buf);
      curval= 1;
      i++;  goto skip1;
      break;
    case '.':
      buf[bufco++]= '\0';  yoko= atoi(buf);
      curval= 0;
      i++;  goto skip1;
      break;
    default:
      if ( '0' <= str[i] && str[i] <= '9' ){
	buf[bufco++]= str[i];
      }else{
	printf("make_pattern() : invalid code header for pattern!\n");
	return;
      }
      break;
    }
  }

 skip1:
  X_max= yoko-1;
  Y_max= tate-1;
  _read_guide_check_flag= 1;
  _check_first_time();
  for( ; i<tate*yoko; i++){
    switch (str[i]){
    case '\0' :
      return;
      break;
    default:
      if       ( '0' <= str[i] && str[i] <= '9' ){
	runlength= str[i]-'0';
      }else if ( 'a' <= str[i] && str[i] <= 'z' ){
	runlength= str[i]-'a'+10;
      }else{
	printf("make_pattern() : invalid code for pattern! (%c)\n",str[i]);
	return;
      }
      for(j=0; j<runlength; j++){
	ptt[tateco][yokoco]= curval;
	tateco++;
	if (tateco>=tate){ yokoco++; tateco= 0; }
      }
      curval= !curval;
      break;
    } /* switch */
  }
}


void make_hidden_pattern(char *str){
  int i, j;
  char buf[10];
  int bufco= 0;
  int tate= 0, yoko= 0, curval= 0, runlength= 0;
  int tateco= 0, yokoco= 0;

  /* strǥɤƥѥ */
  for(i=0; ; i++){
    switch (str[i]){
    case '\0' :
      printf("make_hidden_pattern() : no code for pattern!\n");
      return;
      break;
    case ':':
      buf[bufco++]= '\0';  tate= atoi(buf);
      bufco= 0;
      break;
    case '#':
      buf[bufco++]= '\0';  yoko= atoi(buf);
      curval= 1;
      i++;  goto skip1;
      break;
    case '.':
      buf[bufco++]= '\0';  yoko= atoi(buf);
      curval= 0;
      i++;  goto skip1;
      break;
    default:
      if ( '0' <= str[i] && str[i] <= '9' ){
	buf[bufco++]= str[i];
      }else{
	printf("make_hidden_pattern() : invalid code header for pattern!\n");
	return;
      }
      break;
    }
  }

 skip1:
  X_max_hidden= yoko-1;
  Y_max_hidden= tate-1;
  for( ; i<tate*yoko; i++){
    switch (str[i]){
    case '\0' :
      return;
      break;
    default:
      if       ( '0' <= str[i] && str[i] <= '9' ){
	runlength= str[i]-'0';
      }else if ( 'a' <= str[i] && str[i] <= 'z' ){
	runlength= str[i]-'a'+10;
      }else{
	printf("make_hidden_pattern() : invalid code for pattern! (%c)\n",str[i]);
	return;
      }
      for(j=0; j<runlength; j++){
	hidden_ptt[tateco][yokoco]= curval;
	tateco++;
	if (tateco>=tate){ yokoco++; tateco= 0; }
      }
      curval= !curval;
      break;
    } /* switch */
  }
}


void set_xy_range_check_flag(int f){
  _xy_range_check_flag= f;
}

int check_xy_range(int px, int py){
  if (px<0 || px>X_max || py<0 || py>Y_max){
    return (1==0);
  }else{
    return (1==1);
  }
}


int check_xy_range_hidden(int px, int py){
  if (px<0 || px>X_max_hidden || py<0 || py>Y_max_hidden){
    return (1==0);
  }else{
    return (1==1);
  }
}


int is_marked(int px, int py){
  _check_first_time();
  if (check_xy_range(px, py)){
    if (ptt[py][px]==1){
      return 1;
    }else{
      return 0;
    }
  }else{
    if (_xy_range_check_flag){
      fprintf(stderr,"is_marked() : ΤκɸǤ\n");
    }
    return 0;
  }
}


int is_marked_hidden(int px, int py){
  /* _check_first_time(); */
  if (check_xy_range_hidden(px, py)){
    if (hidden_ptt[py][px]==1){
      return 1;
    }else{
      return 0;
    }
  }else{
    if (_xy_range_check_flag){
      fprintf(stderr,"is_marked_hidden() : ΤκɸǤ\n");
    }
    return 0;
  }
}

int clear_one_point(int px, int py){
  _check_first_time();
  if (check_xy_range(px, py)){
    ptt[py][px]= 0;
    return 0;
  }else{
    if (_xy_range_check_flag){
      fprintf(stderr,"clear_one_point() : clearκɸǤ\n");
    }
    return 1;
  }
}


int mark_one_point(int px, int py){
  _check_first_time();
  if (check_xy_range(px, py)){
    ptt[py][px]= 1;
    return 0;
  }else{
    if (_xy_range_check_flag){
      fprintf(stderr,"mark_one_point() : markκɸǤ\n");
    }
    return 1;
  }
}


int invert_one_point(int px, int py){
  _check_first_time();
  if (check_xy_range(px, py)){
    ptt[py][px]= (ptt[py][px]==1)? 0 : 1; /* ȿž */
    return 0;
  }else{
    if (_xy_range_check_flag){
      fprintf(stderr,"invert_one_point() : invertκɸǤ\n");
    }
    return 1;
  }
}


/* Ǿ a,  b  */
double  f_random(double a, double b){
  return ((double)rand()/RAND_MAX)*(b-a)+a;
}

/* 0, 1, 2, .... (i-1)  */
int random_int(int i){
  return (int) f_random(0.0, (double)i - 1.0e-10);
}


void pick_one_point(int *px, int *py){
  *px=(int)( random_int(X_max+1) );
  *py=(int)( random_int(Y_max+1) );
}



















#if 0 /* ################################################################### */
/* ɸϤ ɤɤ߹
   guide_v[][], guide_h[][], guide_vkosu[], guide_hkosu[]
    */
void read_guide_from_stdin(){
  char buf[256], d[256];
  int i, j, k, cur;

  Y_max= -1;  X_max= -1;

  while(fgets(buf,256,stdin)){
    if (buf[0]=='h'){
      sscanf(buf,"%s %d",dummystr, &Y_max);  Y_max--;
      Vguide_max= ((Y_max+1)+1)/2 - 1; /* verticalɤκĿ-1 */
      if (Y_max<0){ die("horizontalθĿ꤬ޤ"); }
      if ((Y_max+1)>_HMAX){ die("horizontalɤ¿ɤ߹ޤ"); }
      for(i=0; i<=Y_max; i++){
	guide_hkosu[i]= 0;  k= 0;
	cur= 0;
	if(fgets(buf,256,stdin)){    /* Լä, */
	  if (!( ('1'<=buf[0] && buf[0]<='9')||buf[0]=='\n' )){
	    die("horizontalɥǡΥեޥåȤޤ");
	  }
	  for(j=0; j<256; j++){    /* ʸĸ --------------------- */
	    if (buf[j]==' ' || buf[j]=='\0'){
	      if (cur != 0){
		d[cur]= '\0';
		guide_h[i][k++]= atoi(d);
		guide_hkosu[i]++;  
		cur = 0;
	      }
	      if (buf[j]=='\0'){  break; }
	    }else{
	      d[cur++]=buf[j];
	    }
	  } /* ------------------------------------------------------ */
	}else{
	  die("horizontalɥǡΥեޥåȤޤ");
	}
	for(k=guide_hkosu[i]; k<=Hguide_max; k++){ guide_h[i][k]= 0; }
      }
    }

    if (buf[0]=='v'){
      sscanf(buf,"%s %d",dummystr, &X_max);  X_max--;
      Hguide_max= ((X_max+1)+1)/2 - 1; /* horizontalɤκĿ-1 */
      if (X_max<0){ die("verticalθĿ꤬ޤ"); }
      if ((X_max+1)>_VMAX){ die("verticalɤ¿ɤ߹ޤ"); }
      for(i=0; i<=X_max; i++){
	guide_vkosu[i]= 0;  k= 0;
	cur= 0;
	if (fgets(buf,256,stdin)){    /* Լä, */
	  if (!( ('1'<=buf[0] && buf[0]<='9')||buf[0]=='\n' )){
	    die("verticalɥǡΥեޥåȤޤ");
	  }
	  for(j=0; j<256; j++){    /* ʸĸ --------------------- */
	    if (buf[j]==' ' || buf[j]=='\0'){
	      if (cur != 0){
		d[cur]= '\0';
		guide_v[i][k++]= atoi(d);
		guide_vkosu[i]++;  
		cur = 0;
	      }
	      if (buf[j]=='\0'){  break; }
	    }else{
	      d[cur++]=buf[j];
	    }
	  }/* ------------------------------------------------------------- */
	}else{
	  die("verticalɥǡΥեޥåȤޤ");
	}
	for(k=guide_vkosu[i]; k<=Vguide_max; k++){ guide_v[i][k]= 0; }
      }
    }
  } /* while( */
  if (X_max<0 || Y_max<0){
    die("ɥǡɤ߹ߤ˼Ԥޤ");
  }
  _read_guide_check_flag= 1;
}


void print_guide(){
  int h, v, i;

  if (_read_guide_check_flag<0){
    die("ɥǡޤ");
  }
  printf("horizontal %d\n",Y_max+1);
  for(h=0; h<=Y_max; h++){
    for(i=0; i<=Hguide_max; i++){
      printf("%d ",guide_h[h][i]);
    }
    printf("\n");
  }
  printf("vertical %d\n",X_max+1);
  for(v=0; v<=X_max; v++){
    for(i=0; i<=Vguide_max; i++){
      printf("%d ",guide_v[v][i]);
    }
    printf("\n");
  }
}

void parse_ptt_horizontally(int rowc){
  /* (rowc+1)th Horizontal line (row) ˤĤ
     suitei_h[][], suitei_hkosu[] ׻ */
  int col, len, co;

  /* ʿ˥󤹤 */
  len= 0; co= 0;
  for(col=0; col<=X_max; col++){
    if (ptt[rowc][col]!=0){
      len = len +1;
    }else{
      if (len!=0){  suitei_h[rowc][co++]=len;  }
      len= 0;
    }
  }
  if (len!=0){  suitei_h[rowc][co++]=len;  }
  suitei_hkosu[rowc]= co;
  for(; co<=Hguide_max; co++){
    suitei_h[rowc][co]=0;   /* Ĥˤ 0 򤤤Ƥ */
  }
}


void parse_ptt_vertically(int colc){
  /* (colc+1)th Vertical line (column) ˤĤ
     suitei_v[][], suitei_vkosu[] ׻ */
  int row, len, co;

  /* ľ˥󤹤 */
  len= 0; co= 0;
  for(row=0; row<=Y_max; row++){
    if (ptt[row][colc]!=0){
      len = len +1;
    }else{
      if (len!=0){  suitei_v[colc][co++]=len;  }
      len= 0;
    }
  }
  if (len!=0){  suitei_v[colc][co++]=len;  }
  suitei_vkosu[colc]= co;
  for(; co<=Vguide_max; co++){
    suitei_v[colc][co]=0;   /* Ĥˤ 0 򤤤Ƥ */
  }
}


int get_zentai_err(){
  int i;
  int zentai_err= 0;

  for(i=0; i<=Y_max; i++){  zentai_err+= get_horizontal_err(i);  }
  for(i=0; i<=X_max; i++){  zentai_err+= get_vertical_err(i);  }

  return zentai_err;
}


int get_vertical_err(int i){
  /* (i+1)th Vertical line (column) */
  int k, err;

  _check_first_time();

  if (i<0 || i>X_max){
    fprintf(stderr,"get_vertical_err()ΰͤǤ\n");
    return 0;
  }
  parse_ptt_vertically(i);
  err= 0;
  for(k=0; k<=Vguide_max; k++){  err += abs(suitei_v[i][k]-guide_v[i][k]); }
  /* return 0*err1 + 0*err2 + 1*err; */
  return err;
}


int get_horizontal_err(int i){
  /* (i+1)th Horizontal line (row) */
  int k, err;

  _check_first_time();

  if (i<0 || i>Y_max){
    fprintf(stderr,"get_horizontal_err()ΰͤǤ\n");
    return 0;
  }
  parse_ptt_horizontally(i);
  err= 0;
  for(k=0; k<=Hguide_max; k++){  err += abs(suitei_h[i][k]-guide_h[i][k]); }
  /* return 0*err1 + 0*err2 + 1*err; */
  return err;
}


void print_pattern_with_err(){
  int i, j;

  _check_first_time();

  printf("\n");
#ifdef PRINT_HANKAKU_PATTERN
  for(j=0; j<=X_max; j++){  printf("%1d",get_vertical_err(j))%10; }
#else
  for(j=0; j<=X_max; j++){  printf("%2d",get_vertical_err(j)); }
#endif
  printf("\n");
  for(i=0; i<=Y_max; i++){
    for(j=0; j<=X_max; j++){
      if (ptt[i][j]==0){
#ifdef PRINT_HANKAKU_PATTERN
	printf(".");
#else
	printf("");
#endif
      }else{
#ifdef PRINT_HANKAKU_PATTERN
	printf("#");
#else
	printf("");
#endif
      }
    }
    printf(" %2d",get_horizontal_err(i));
    printf("\n");
  }
  printf("\n");
}

#endif /* ################################################################# */
